#include "rbo.h"

void
rbo_init(RBO* self)
{
	glGenRenderbuffers(1, &self->handle);
}

void
rbo_bind(RBO* self)
{
	glBindRenderbuffer(GL_FRAMEBUFFER, self->handle);
}

void
rbo_unbind(void)
{
	glBindRenderbuffer(GL_FRAMEBUFFER, 0);
}

void
rbo_storage_set(RBO* self, ivec2 size)
{
	glRenderbufferStorage(GL_RENDERBUFFER, GL_DEPTH24_STENCIL8, size[0], size[1]);
}

void
rbo_free(RBO* self)
{
	glDeleteRenderbuffers(1, &self->handle);
	memset(self, '\0', sizeof(RBO));
}
