#include "component_collect.h"

void _component_collect_circle_set(ComponentCollect* self, ECS* ecs);

void
_component_collect_circle_set(ComponentCollect* self, ECS* ecs)
{
	ComponentCircleCollider* circleCollider;

	circleCollider = ecs_component_get(ecs, COMPONENT_CIRCLE_COLLIDER, self->component.id);

	self->circle.position[0] = circleCollider->circle.position[0];
	self->circle.position[1] = circleCollider->circle.position[1];
}

void
component_collect_init(ComponentCollect* self, ECS* ecs, f32 radius)
{
	self->circle.radius = radius;
}

void
component_collect_tick(ComponentCollect* self, ECS* ecs)
{
	_component_collect_circle_set(self, ecs);
}
