#pragma once

#include "../physics/component_physics.h"

typedef struct ComponentHoming
{
	Component component;
	EntityID targetID;
	f32 speed;
	bool isHoming;
} ComponentHoming;

void component_homing_tick(ComponentHoming* self, ECS* ecs);
void component_homing_init(ComponentHoming* self, ECS* ecs, EntityID targetID, f32 speed);

static const ComponentInfo COMPONENT_HOMING_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL,
			(ECSFunction)component_homing_tick, 
			NULL,
			NULL
		}
	},
	.type = COMPONENT_HOMING,
	.size = sizeof(ComponentHoming)
};
