#include "component_levitate.h"

void
component_levitate_add(ComponentLevitate* self, ECS* ecs)
{
	self->counterID = entity_counter_add(ecs);
}

void
component_levitate_delete(ComponentLevitate* self, ECS* ecs)
{
	ecs_entity_delete(ecs, self->counterID);
}

void
component_levitate_tick(ComponentLevitate* self, ECS* ecs)
{
	ComponentCounter* counter;
	ComponentWorldObject* worldObject;

	counter = ecs_component_get(ecs, COMPONENT_COUNTER, self->counterID);
	worldObject = ecs_component_get(ecs, COMPONENT_WORLD_OBJECT, self->component.id);

	worldObject->heightOffset = self->distance + ((self->distance / 2.0f) * cos((f32)counter->value / self->frequency));
}

void
component_levitate_init
(
 	ComponentLevitate* self,
	ECS* ecs,
	f32 distance,
	f32 frequency
)
{
	ComponentWorldObject* worldObject;

	worldObject = ecs_component_get(ecs, COMPONENT_WORLD_OBJECT, self->component.id);

	self->frequency = frequency;
	self->distance = distance;

	worldObject->isGravityAffected = false;
}
