#pragma once

#include "component_world_object.h"
#include "../../entity/utility/entity_counter.h"

typedef struct ComponentLevitate
{
	Component component;
	f32 distance;
	f32 frequency;
	EntityID counterID;
} ComponentLevitate;

void component_levitate_add(ComponentLevitate* self, ECS* ecs);
void component_levitate_delete(ComponentLevitate* self, ECS* ecs);
void component_levitate_tick(ComponentLevitate* self, ECS* ecs);

void
component_levitate_init
(
	ComponentLevitate* self, 
	ECS* ecs,
	f32 distance,
	f32 frequency
);

static const ComponentInfo COMPONENT_LEVITATE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_levitate_add, 
			(ECSFunction)component_levitate_delete, 
			(ECSFunction)component_levitate_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_LEVITATE,
	.size = sizeof(ComponentLevitate)
};
