#include "component_take_food.h"

void
component_take_food_tick(ComponentTakeFood* self, ECS* ecs)
{
	ComponentCircleCollider* circleCollider;

	circleCollider = ecs_component_get(ecs, COMPONENT_CIRCLE_COLLIDER, self->component.id);

	self->isTakeFood = false;

	ecs->isLog = false;

	for (s32 i = 0; i < (s32)circleCollider->collisions.count; i++)
	{
		ComponentFood* collideFood;
		ComponentFood* food;
		EntityID* id;

		id = vector_get(&circleCollider->collisions, i);

		collideFood = ecs_component_get(ecs, COMPONENT_FOOD, *id);
		food = ecs_component_get(ecs, COMPONENT_FOOD, self->component.id);

		if (!collideFood)
			continue;

		if (collideFood->value > 0)
		{
			food->value += (collideFood->value * food->multiplier);
			collideFood->value = 0;
			self->isTakeFood = true;
		}
	}

	ecs->isLog = true;
}
