#include "component_circle_collider.h"

void _component_circle_collider_collisions_tick(ComponentCircleCollider* self, ECS* ecs);

void
_component_circle_collider_collisions_tick(ComponentCircleCollider* self, ECS* ecs)
{
	vector_clear(&self->collisions);

	for (s32 i = 0; i < (s32)ecs->lists[COMPONENT_CIRCLE_COLLIDER].components.count; i++)
	{
		EntityID* id;
		ComponentCircleCollider* circleCollider;

		id = vector_get(&ecs->lists[COMPONENT_CIRCLE_COLLIDER].components, i);

		if (*id == self->component.id)
			continue;

		circleCollider = ecs_component_get(ecs, COMPONENT_CIRCLE_COLLIDER, *id);

		if (circle_collide_check(&self->circle, &circleCollider->circle))
			vector_push(&self->collisions, id);
	}
}

bool
component_circle_collider_collide_check(ComponentCircleCollider* self, ECS* ecs, EntityID id)
{
	for (s32 i = 0; i < (s32)self->collisions.count; i++)
	{
		EntityID* checkID;

		checkID = vector_get(&self->collisions, i);

		if (*checkID == id)
			return true;
	}

	return false;
}

void
component_circle_collider_add(ComponentCircleCollider* self, ECS* ecs)
{
	vector_init(&self->collisions, sizeof(EntityID));
}

void
component_circle_collider_delete(ComponentCircleCollider* self, ECS* ecs)
{
	vector_free(&self->collisions);
}

void
component_circle_collider_tick(ComponentCircleCollider* self, ECS* ecs)
{
	_component_circle_collider_collisions_tick(self, ecs);	
}

void
component_circle_collider_init(ComponentCircleCollider* self, vec2 position, f32 radius)
{
	glm_vec2_copy(position, self->circle.position);
	self->circle.radius = radius;
}
