#pragma once

#include "../../ecs_entity.h"

#include "../../../../engine/circle.h"

typedef struct ComponentCircleCollider
{
	Component component;
	Circle circle;
	Vector collisions; /* EntityID */
} ComponentCircleCollider;

void component_circle_collider_add(ComponentCircleCollider* self, ECS* ecs);
void component_circle_collider_delete(ComponentCircleCollider* self, ECS* ecs);
void component_circle_collider_tick(ComponentCircleCollider* self, ECS* ecs);
bool component_circle_collider_collide_check(ComponentCircleCollider* self, ECS* ecs, EntityID id);

void component_circle_collider_init
(
 	ComponentCircleCollider* self,
	vec2 position,
	f32 radius
);

static const ComponentInfo COMPONENT_CIRCLE_COLLIDER_INFO = 
{
	.system = 
	{
		.functions = 
		{ 

			(ECSFunction)component_circle_collider_add,
			(ECSFunction)component_circle_collider_delete,
			(ECSFunction)component_circle_collider_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_CIRCLE_COLLIDER,
	.size = sizeof(ComponentCircleCollider)
};
