#include "component_delete_on_timer.h"

void
component_delete_on_timer_add(ComponentDeleteOnTimer* self, ECS* ecs)
{
	ComponentTimer* timer;
	
	self->timerID = entity_timer_add(ecs, -1);

	timer = ecs_component_get(ecs, COMPONENT_TIMER, self->timerID);

	timer->component.isDisabled = true;
}


void
component_delete_on_timer_delete(ComponentDeleteOnTimer* self, ECS* ecs)
{
	ecs_entity_delete(ecs, self->timerID);
}

void
component_delete_on_timer_init(ComponentDeleteOnTimer* self, ECS* ecs, s32 value)
{
	ComponentTimer* timer;

	timer = ecs_component_get(ecs, COMPONENT_TIMER, self->timerID);

	component_timer_init(timer, ecs, value);

	timer->component.isDisabled = false;
}

void
component_delete_on_timer_tick(ComponentDeleteOnTimer* self, ECS* ecs)
{
	ComponentTimer* timer;

	timer = ecs_component_get(ecs, COMPONENT_TIMER, self->timerID);

	if (timer->isFinished)
		ecs_entity_delete(ecs, self->component.id);
}
