#include "component_color_match.h"

void _component_color_match_set(ComponentColorMatch* self, ECS* ecs);

void
_component_color_match_set(ComponentColorMatch* self, ECS* ecs)
{
	ComponentTextureQuad* matchTextureQuad;
	ComponentTextureQuad* textureQuad;

	matchTextureQuad = ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, self->matchID);

	if (matchTextureQuad == NULL)
		return;

	textureQuad = ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, self->component.id);

	glm_vec4_copy(matchTextureQuad->color, textureQuad->color);
	glm_vec4_copy(matchTextureQuad->colorCover, textureQuad->colorCover);
}

void
component_color_match_tick(ComponentColorMatch* self, ECS* ecs)
{
	_component_color_match_set(self, ecs);
}

void
component_color_match_init(ComponentColorMatch* self, ECS* ecs, EntityID matchID)
{
	self->matchID = matchID;

	_component_color_match_set(self, ecs);
}
