#pragma once

#include "../../entity/visual/entity_sprite.h"

static const f32 COMPONENT_DROP_SHADOW_Z_OFFSET = 0.001f;

typedef struct ComponentDropShadow
{
	Component component;
	vec4 color;
	vec2 offset;
	bool isSpriteInit;
	EntityID spriteID;
} ComponentDropShadow;

void component_drop_shadow_init(ComponentDropShadow* self, ECS* ecs, vec4 color, vec2 offset);
void component_drop_shadow_tick(ComponentDropShadow* self, ECS* ecs);
void component_drop_shadow_add(ComponentDropShadow* self, ECS* ecs);
void component_drop_shadow_delete(ComponentDropShadow* self, ECS* ecs);

static const ComponentInfo COMPONENT_DROP_SHADOW_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_drop_shadow_add, 
			(ECSFunction)component_drop_shadow_delete, 
			(ECSFunction)component_drop_shadow_tick, 
			NULL
		}
	},
	.type = COMPONENT_DROP_SHADOW,
	.size = sizeof(ComponentDropShadow)
};
