#pragma once

#include "../../ecs_entity.h"

#include "component_texture_quad.h"

#include "../../entity/utility/entity_counter.h"

typedef struct ComponentPulsate
{
	Component component;
	vec2 minScale;
	vec2 maxScale;
	f32 frequency;
	EntityID counterID;
} ComponentPulsate;

void component_pulsate_add(ComponentPulsate* self, ECS* ecs);
void component_pulsate_delete(ComponentPulsate* self, ECS* ecs);
void component_pulsate_tick(ComponentPulsate* self, ECS* ecs);

void
component_pulsate_init
(
	ComponentPulsate* self, 
	ECS* ecs,
	vec2 minScale,
	vec2 maxScale,
	f32 frequency
);

static const ComponentInfo COMPONENT_PULSATE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_pulsate_add, 
			(ECSFunction)component_pulsate_delete, 
			(ECSFunction)component_pulsate_tick,
			NULL,
			NULL
		}
	},
	.type = COMPONENT_PULSATE,
	.size = sizeof(ComponentPulsate)
};
