#include "component_scale_value.h"

void _component_scale_value_set(ComponentScaleValue* self, ECS* ecs);

void
_component_scale_value_set(ComponentScaleValue* self, ECS* ecs)
{
	ComponentTextureQuad* textureQuad;
	void* component;
	f32 value;
	f32 max;
	f32 percent;
	vec2 sizeDifference;
	vec2 scaledSize;

	textureQuad = ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, self->component.id);
	component = ecs_component_get(ecs, self->type, self->id);

	memcpy(&value, (u8*)component + sizeof(Component), sizeof(f32));
	memcpy(&max, (u8*)component + sizeof(Component) + sizeof(f32), sizeof(f32));

	percent = value / max;

	glm_vec2_sub(self->maxSize, self->minSize, sizeDifference);
	glm_vec2_scale(sizeDifference, percent, scaledSize);
	glm_vec2_copy(self->minSize, textureQuad->size);
	glm_vec2_add(textureQuad->size, scaledSize, textureQuad->size);
}

void
component_scale_value_init(ComponentScaleValue* self, ECS* ecs, vec2 minSize, vec2 maxSize, ComponentType type, EntityID id)
{
	self->id = id;
	self->type = type;
	glm_vec2_copy(minSize, self->minSize);
	glm_vec2_copy(maxSize, self->maxSize);

	_component_scale_value_set(self, ecs);
}

void
component_scale_value_tick(ComponentScaleValue* self, ECS* ecs)
{
	_component_scale_value_set(self, ecs);
}
