#pragma once

#include "../../component/game/component_food.h"
#include "../../component/game/component_solid.h"
#include "../../component/game/component_take_food.h"
#include "../../component/game/component_threshold.h"
#include "../../component/game/component_world_object.h"
#include "../../component/visual/component_atlas.h"
#include "../../component/animation/component_animation_target.h"

static const TextureType TARGET_TEXTURE = TEXTURE_TARGET;
static const vec2 TARGET_SIZE = {1024.0f, 1024.0f};
static const f32 TARGET_HEIGHT_OFFSET = 0.0f;
static const f32 TARGET_RADIUS = 192.0f;
static const s32 TARGET_FOOD_MAX = 9999;
static const s32 TARGET_FOOD_MULTIPLIER = 1;

static const ivec2 TARGET_ATLAS_FRAME_SIZE = {256, 256};
static const ivec2 TARGET_ATLAS_SIZE = {5, 5};

#define ENTITY_TARGET_DEPENDENCY_COUNT 9
static const ComponentType ENTITY_TARGET_DEPENDENCIES[ENTITY_TARGET_DEPENDENCY_COUNT] =
{
	COMPONENT_WORLD_OBJECT,
	COMPONENT_FOOD,
	COMPONENT_THRESHOLD,
	COMPONENT_TAKE_FOOD,
	COMPONENT_STAGE,
	COMPONENT_SOLID,
	COMPONENT_ATLAS,
	COMPONENT_ANIMATION,
	COMPONENT_ANIMATION_TARGET
};

EntityID entity_target_add(ECS* ecs, const vec3 position, u32 threshold, u32 stage, EntityID playerID);
