#include "entity_level_select_button.h"

EntityID
entity_level_select_button_add(ECS* ecs, vec3 position, LevelStatusType status, u32 index)
{
	EntityID id;

	id = entity_button_add
	(
		ecs, 
		&ecs->resources->textures[TEXTURE_LEVEL_SELECT_BUTTONS],
		ENTITY_LEVEL_SELECT_BUTTON_SIZE,
		position
	);

	ecs_components_add(ecs, ENTITY_LEVEL_SELECT_BUTTON_DEPENDENCIES, ENTITY_LEVEL_SELECT_BUTTON_DEPENDENCY_COUNT, id);

	component_atlas_init
	(
		ecs_component_get(ecs, COMPONENT_ATLAS, id),
		ecs,
		ENTITY_LEVEL_SELECT_BUTTON_ATLAS_FRAME_SIZE,
		ENTITY_LEVEL_SELECT_BUTTON_ATLAS_SIZE,
		index
	);

	if (status == LEVEL_STATUS_LOCKED)
	{
		ComponentTextureQuad* textureQuad;
		ComponentButton* button;

		textureQuad = ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, id);
		button = ecs_component_get(ecs, COMPONENT_BUTTON, id);

		glm_vec4_copy(ENTITY_LEVEL_SELECT_BUTTON_LOCKED_COLOR, textureQuad->color);

		button->component.isFunctionDisabled[ECS_FUNCTION_TICK] = true;
	}

	entity_level_select_button_icon_add
	(
		ecs,
		status,
		id
	);

	return id;
}
