#include "entity_level_select_button_icon.h"

EntityID
entity_level_select_button_icon_add(ECS* ecs, LevelStatusType status, EntityID levelSelectButtonID)
{
	EntityID id;
	ComponentTextureQuad* levelSelectButtonTextureQuad;
	vec3 position;

	levelSelectButtonTextureQuad = ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, levelSelectButtonID);

	glm_vec3_copy(levelSelectButtonTextureQuad->position, position);

	glm_vec3_add(position, ENTITY_LEVEL_SELECT_BUTTON_ICON_OFFSET, position);

	id = entity_sprite_add
	(
		ecs, 
		&ecs->resources->textures[TEXTURE_LEVEL_SELECT_ICONS],
		RENDERER_BUFFER_UI,
		ORIGIN_CENTER,
		ENTITY_LEVEL_SELECT_BUTTON_ICON_SIZE,
		position
	);

	ecs_components_add(ecs, ENTITY_LEVEL_SELECT_BUTTON_ICON_DEPENDENCIES, ENTITY_LEVEL_SELECT_BUTTON_ICON_DEPENDENCY_COUNT, id);

	component_atlas_init
	(
		ecs_component_get(ecs, COMPONENT_ATLAS, id),
		ecs,
		ENTITY_LEVEL_SELECT_BUTTON_ICON_ATLAS_FRAME_SIZE,
		ENTITY_LEVEL_SELECT_BUTTON_ICON_ATLAS_SIZE,
		status
	);

	component_color_match_init
	(
		ecs_component_get(ecs, COMPONENT_COLOR_MATCH, id),
		ecs,
		levelSelectButtonID
	);

	return id;
}
