#include "entity_meter.h"

EntityID
entity_meter_add(ECS* ecs, Texture* fillTexture, const vec3 position, ComponentType componentType, EntityID valueID)
{
	EntityID id;
	vec3 fillPosition;

	glm_vec3_copy(position, fillPosition);
	glm_vec3_add(fillPosition, ENTITY_METER_FILL_OFFSET, fillPosition);

	id = entity_sprite_add
	(
		ecs,
		fillTexture,
		RENDERER_BUFFER_UI,
		ORIGIN_TOP_LEFT,
		ENTITY_METER_FILL_MIN_SIZE,
		fillPosition
	);

	ecs_components_add(ecs, ENTITY_METER_DEPENDENCIES, ENTITY_METER_DEPENDENCY_COUNT, id);

	component_scale_value_init
	(
		ecs_component_get(ecs, COMPONENT_SCALE_VALUE, id),
		ecs,
		ENTITY_METER_FILL_MIN_SIZE,
		ENTITY_METER_FILL_MAX_SIZE,
		componentType,
		valueID
	);

	entity_sprite_add
	(
		ecs, 
		&ecs->resources->textures[TEXTURE_METER], 
		RENDERER_BUFFER_UI,
		ORIGIN_TOP_LEFT,
		ENTITY_METER_SIZE, 
		position
	);

	return id;
}
