#include "entity_sprite_atlas.h"

EntityID
entity_sprite_atlas_add
(
	ECS* ecs, 
	Texture* texture, 
	RendererBuffer buffer, 
	Origin origin, 
	vec2 size, 
	vec3 position, 
	ivec2 frameSize, 
	ivec2 atlasSize, 
	u32 index
)
{
	EntityID id;

	id = entity_sprite_add
	(
		ecs,
		texture,
		buffer,
		origin,
		size,
		position
	);

	ecs_components_add(ecs, ENTITY_SPRITE_ATLAS_DEPENDENCIES, ENTITY_SPRITE_ATLAS_DEPENDENCY_COUNT, id);
	
	component_atlas_init
	(
		ecs_component_get(ecs, COMPONENT_ATLAS, id),
		ecs,
		frameSize,
		atlasSize,
		index
	);

	return id;
}
