#pragma once

#include "RENDER_COMMON.h"

#define TEXTURE_QUAD_UNIFORM_COLOR "u_color"
#define TEXTURE_QUAD_UNIFORM_COLOR_COVER "u_colorCover"
#define TEXTURE_QUAD_UNIFORM_TRANSFORM "u_transform"
#define TEXTURE_QUAD_UNIFORM_MODEL "u_model"
#define TEXTURE_QUAD_UNIFORM_VIEW "u_view"
#define TEXTURE_QUAD_UNIFORM_PROJECTION "u_projection"
#define TEXTURE_QUAD_UNIFORM_SIZE "u_size"
#define TEXTURE_QUAD_UNIFORM_TEXTURE "u_texture"

void texture_quad_draw
(
	Texture* texture,
	Renderer* renderer, 
	Shader* shader, 
	vec2 uvMin,
	vec2 uvMax,
	mat4 model, 
	mat4 view,
	mat4 projection,
	vec2 size, 
	vec4 color, 
	vec4 colorCover, 
	Flip flip
); 

#define TEXTURE_QUAD_COLOR_DEFAULT (f32*)OPAQUE

static const vec2 TEXTURE_QUAD_UV_MIN_DEFAULT = {0.0f, 0.0f};
static const vec2 TEXTURE_QUAD_UV_MAX_DEFAULT = {1.0f, 1.0f};
static const Flip TEXTURE_QUAD_FLIP_DEFAULT = FLIP_NONE;
static const Origin TEXTURE_QUAD_ORIGIN_DEFAULT = ORIGIN_TOP_LEFT;
